# © 2021 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html)

from odoo import _, models
from odoo.exceptions import UserError


class ScopBordereauUpdate(models.TransientModel):
    """
    This wizard will update all the selected bordereaux
    """

    _name = "scop.bordereau.update"
    _description = "Mettre à jour les bordereaux sélectionnés"

    def bordereau_update(self):
        context = dict(self._context or {})
        active_ids = context.get("active_ids", []) or []

        for record in self.env["scop.bordereau"].browse(active_ids):
            if record.state != "new":
                raise UserError(
                    _(
                        "Impossible de mettre à jour un bordereau "
                        "qui n'est pas à l'état de brouillon"
                    )
                )
            record.create_cotiz_and_lines()
        return {"type": "ir.actions.act_window_close"}
